{{#if @model.map.name}}
  {{page-title @model.map.name " | " (t "map view") " | " (capitalize (t "maps"))}}
{{/if}}

<Fullscreen class="map-wrapper {{unless this.embed.isEnabled 'disable'}}" @isFullscreen={{this.isFullscreen}} @onFullScreen={{this.fullScreen}} @onFullscreenRequest={{this.fullscreenRequest}}>
  <Filters::MapSearchBis
    @term={{this.term}}
    @isSearching={{this.loading.isLoading}}
    @isActive={{this.hasContent}}
    @onChange={{this.updateSearch}}
    @onActivate={{this.enableSpotlight}}
    @onDeactivate={{this.disableSpotlight}}
    @onBackToResults={{this.backToResults}}
    @onFilterIcons={{this.filterIcons}}
    @iconsPreview={{@model.icons}}
    @onSelectIcon={{this.selectIcon}}
    @onDeselectIcon={{this.deselectIcon}}
    @canGoBack={{this.canGoBack}}
    @onBackToSearch={{this.checkSearch}}
    {{did-insert this.setupPanel}}
    class="{{if this.embed.isEnabled 'is-embedded'}} {{if this.hasFeatureContent 'has-feature-content'}}"
    as |contentType|
  >
    {{#if (eq contentType "pills")}}
      {{#each @model.selectedIconList as |icon|}}
        <Browse::Icon::Pill class="mb-1" @icon={{icon}} @onRemove={{fn this.deselectIcon icon}} />
      {{/each}}
    {{/if}}

    {{#if (eq contentType "content")}}
      {{outlet}}
    {{/if}}
  </Filters::MapSearchBis>

  <div class="map-view {{if this.isHover 'cursor-pointer'}}" {{on "contextmenu" this.showMapContextMenu}} {{on "click" this.hideMapContextMenu}}>
    {{#unless this.fastboot.isFastBoot}}
      <Map::Plain as |map|>
        <Map::ContextMenu @onSelect={{this.handleMapContextAction}} @options={{this.contextOptions}} @x={{this.contextX}} @y={{this.contextY}} @map={{map}} @isVisible={{and this.contextX this.contextY}} />

        <Map::View @map={{map}} @extentM={{this.extentM}} @onChangeExtent={{this.handleExtentChange}} @onChangeCenter={{this.changeCenter}} />

        <Map::Layer::Base @map={{map}} @value={{this.selectedBaseMap}} @cacheId={{this.cacheId}} @onSetupError={{this.layerSetupError}} />

        {{#if this.featureTilesUrl}}
          <Map::Layer::VectorTiles
            @style={{this.mapStyles.styleFunction}}
            @selectedId={{this.selectedFeature}}
            @map={{map}}
            @bearer={{this.bearer}}
            @url={{this.tilesUrl}}
            @debugTiles={{this.debugTiles}}
            @onLayerUpdate={{fn this.setupLayer map}}
            @onHover={{this.hoverFeature}}
            @onSelect={{this.selectFeature}}
            @cacheId={{this.cacheId}}
          />
        {{/if}}

        {{#if (eq this.featureSelection.type "pending")}}
          <Map::Overlay @map={{map}} @position={{this.featureSelection.coordinates}}>
            <div class="pending-label content site-list p-2 text-info">
              {{t "feature-pending-message"}}
            </div>
          </Map::Overlay>
        {{/if}}

        {{#if (eq this.featureSelection.type "group")}}
          <Map::Overlay @map={{map}} @position={{this.featureSelection.coordinates}}>
            <Map::Marker::Group @map={{map}} @feature={{this.featureSelection.group}} @onZoom={{this.selectFeature}} @onSelect={{this.selectFeatureFromGroup}} />
          </Map::Overlay>
        {{/if}}

        {{#if this.position.hasGeoLocationPosition}}
          <Map::Layer::UserPosition @map={{map}} @position={{this.position.center}} @accuracy={{this.position.accuracy}} />
        {{/if}}

        <Map::Container @right={{true}} @bottom={{true}} class="p-1">
          <Map::Controls @onLocalize={{this.localize}} @map={{map}} />
          <Map::BaseMapSelect @list={{this.baseMaps}} @selected={{this.selectedBaseMap}} @onSelect={{this.selectBaseMap}} />
        </Map::Container>

        <Map::Container @left={{true}} @bottom={{true}} @right={{true}}>
          <div class="map-info-toggle {{if this.hasContent 'd-none' 'd-block'}} d-md-none p-1">
            <button type="button" class="btn btn-light btn-lg" {{on "click" this.toggleMapInfo}}>
              <FaIcon @icon="info" />
            </button>
          </div>

          <div class="map-attributions {{if this.hasContent '' 'is-visible'}} {{if this.showMapInfo 'd-block' 'd-none'}} d-md-inline-block">
            {{#if this.mapInfoVisible}}
              <div class="map-info p-2 pb-0">
                <h1 class="m-0 p-0 text-dark">
                  <Link @to={{this.mapLink}} @space={{this.space.currentSpace}} class="show-map" target={{this.linkTarget}}>
                    {{@model.map.name}}
                  </Link>
                </h1>

                {{#if @model.map.tagLine}}
                  <p class="mb-0">
                    {{@model.map.tagLine}}
                  </p>
                {{/if}}

                {{#if @model.map.visibility.team.isLoaded}}
                  <p class="m-0 attributions">
                    <LinkTo @route="browse.teams.team" @model={{@model.map.visibility.team.id}} @query={{hash embed=null}} class="show-team" target={{this.linkTarget}}>
                      {{t "author-label" name=@model.map.visibility.team.name}}
                    </LinkTo>
                  </p>
                {{/if}}

                <div class="map-actions ms-n3">
                  <ModelActions::Map @record={{@model.map}} @isSmall={{true}} />

                  {{#if (or @model.map.showPublicDownloadLinks @model.map.canEdit)}}
                    <Browse::Map::Download @map={{@model.map}} class="d-inline-block dropdown-menu-top" />
                  {{/if}}
                </div>

                {{#if (or @model.map.license.name @model.map.license.url)}}
                  <div class="license">
                    <Browse::License @value={{@model.map.license}} />
                  </div>
                {{/if}}
              </div>
            {{/if}}

            {{#if this.attributions}}
              <p class="m-0 py-1 px-2 fs-7 attributions">
                {{#each this.attributions as |attribution|}}
                  <a target="_blank" href={{attribution.url}} rel="noopener noreferrer" class="attribution">{{attribution.name}}</a>
                {{/each}}
              </p>
            {{/if}}
            <div class="d-grid gap-2">
              <button type="button" class="btn btn-light btn-lg mt-2 d-md-none" {{on "click" this.toggleMapInfo}}>
                {{capitalize (t "close")}}
              </button>
            </div>
          </div>
        </Map::Container>

        <Map::Interaction::DoubleClickZoom @map={{map}} @duration={{150}} @delta={{1}} />
      </Map::Plain>
    {{/unless}}
  </div>
</Fullscreen>

{{#unless this.hideLoading}}
  <FullLoading @isVisible={{this.fastboot.isFastBoot}} />
{{/unless}}